Subject: Re: [PATCH] arch/ppc/8xx_io/enet.c, version 2

From: "Joakim Tjernlund" <[email-masked]>
Date: Wed, 13 Nov 2002 22:19:21 +0100

> ----- Original Message -----
> From: Joakim Tjernlund <[email-masked]>
>
> > You may be right, perhaps one must invalidate the whole buffer before giving it
> > to the CPM/DMA. Suppose you reuse a buffer which has been modified before it
> > was freed and the dcache must write back data to free up space and the buffer,
> > which now is owned by the CPM, get written to.
>
> I beleive this could happen. Since IP does not perform checksumming
> but relies on the link (don't know this really) in that matter, I guess
> the application could get wrong data...

OK, anyone against? Dan?

>
> > I have not seen any corrupted packets and you are the first to report
> > any problems.
>
> Did you run any data integrity tests?
No, normal use, lots of pings etc.

>
> > What modifications have you done?
>
> I haven't used your driver patch. I used the __idea__ of delaying the
> invalidate to the point where you know how much has been received. This was
> in an RTOS ATM driver for a 405. An integrity test showed that some few
> packets was wrong. Data was changed by means of cache lines.

Did you notice any difference in performance when moving the invalidate call?

Any other problems with the patch?

Dan, would you like a new patch or will you fix this?

         Jocke

** Sent via the linuxppc-embedded mail list. See http://lists.linuxppc.org/